package com.zipcoder.payment;

public class Check implements Payment {
    Long id;
    String payerName;
    String routingNumber;
    String accountNumber;

    public Check(){
    }

    public Check(Long id, String payerName, String routingNumber, String accountNumber){
        this.id = id;
        this.payerName = payerName;
        this.routingNumber = routingNumber;
        this.accountNumber = accountNumber;
    }

    public Long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getPayerName() {
        return payerName;
    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getRoutingNumber() {
        return routingNumber;
    }

    public void setRoutingNumber(String routingNumber) {
        this.routingNumber = routingNumber;
    }

    public String getAccountNumber() {
        return accountNumber;
    }

    public void setAccountNumber(String accountNumber) {
        this.accountNumber = accountNumber;
    }

    public String getShortDescription() {
        return ("Check " + getPayerName() + " ***" + getLast4OfAccountNumber());
    }

    public String getLast4OfAccountNumber() {
        StringBuilder last4OfAccount = new StringBuilder();
        for (int i = accountNumber.length()-4; i<accountNumber.length(); i++){
            last4OfAccount.append(accountNumber.charAt(i));
        }
        return last4OfAccount.toString();
    }

    public int compareTo(Payment o) {
        return this.id.compareTo(o.getId());
    }
}
