package com.zipcoder.payment;

public class CreditCard implements Payment {
    Long id;
    String payerName;
    String number;
    int expiredMonth;
    int expiredYear;

    public Long getId() {
        return id;
    }

    public void setId(long id){
        this.id = id;
    }

    public String getPayerName() {
        return payerName;
    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public String getExpiredMonth() {
        return String.format("%02d", expiredMonth);
    }

    public void setExpiredMonth(int expiredMonth) {
        this.expiredMonth = expiredMonth;
    }

    public String getExpiredYear() {
        return String.format("%02d", expiredYear);
    }

    public void setExpiredYear(int expiredYear) {
        this.expiredYear = expiredYear;
    }

    public String getShortDescription() {
        return ("CC " + payerName + " " + getLast4OfNumber() + " " + getExpiredMonth() + "/" + getExpiredYear());
    }

    private String getLast4OfNumber(){
        StringBuilder last4OfNumber = new StringBuilder();
        for (int i = number.length()-4; i<number.length(); i++){
            last4OfNumber.append(number.charAt(i));
        }
        return last4OfNumber.toString();
    }

    public int compareTo(Payment o) {
        return this.id.compareTo(o.getId());
    }
}
