package com.zipcoder.payment;

import org.junit.Test;

import static org.junit.Assert.*;

public class CheckTest {

    @Test
    public void getSetIDTest() {
        Check check = new Check();
        long expected = 12345;
        check.setId(expected);
        long actual = check.getId();
        assertEquals(expected, actual);
    }

    @Test
    public void getSetPayerNameTest() {
        Check check = new Check();
        String expected = "John Doe";
        check.setPayerName(expected);
        String actual = check.getPayerName();
        assertEquals(expected, actual);
    }

    @Test
    public void getSetRoutingNumberTest() {
        Check check = new Check();
        String expected = "00012345";
        check.setRoutingNumber(expected);
        String actual = check.getRoutingNumber();
        assertEquals(expected, actual);
    }

    @Test
    public void getSetAccountNumberTest() {
        Check check = new Check();
        String expected = "123456789";
        check.setAccountNumber(expected);
        String actual = check.getAccountNumber();
        assertEquals(expected, actual);
    }

    @Test
    public void getShortDescription() {
        Check check = new Check();
        String expected = "Check John Doe ***6789";
        check.setPayerName("John Doe");
        check.setAccountNumber("123456789");
        String actual = check.getShortDescription();
        assertEquals(expected, actual);
    }

    @Test
    public void compareToPaypalTest() {
        Paypal paypal = new Paypal();
        paypal.setId(2);
        Check check = new Check();
        check.setId(1);
        int actual = check.compareTo(paypal);
        int expected = -1;
        assertEquals(expected, actual);
    }

    @Test
    public void compareToCreditCardTest() {
        Paypal paypal = new Paypal();
        paypal.setId(1);
        Check check = new Check();
        check.setId(1);
        int actual = check.compareTo(paypal);
        int expected = 0;
        assertEquals(expected, actual);
    }

    @Test
    public void compareToCreditCardTest2() {
        Check check = new Check();
        check.setId(1);
        CreditCard creditCard = new CreditCard();
        creditCard.setId(0);
        int actual = check.compareTo(creditCard);
        int expected = 1;
        assertEquals(expected, actual);
    }
}