package com.zipcoder.payment;

import org.junit.Test;

import static org.junit.Assert.*;

public class CreditCardTest {

    @Test
    public void getSetIDTest() {
        CreditCard creditCard = new CreditCard();
        long expected = 12345;
        creditCard.setId(expected);
        long actual = creditCard.getId();
        assertEquals(expected, actual);
    }
    @Test
    public void getSetPayerNameTest() {
        CreditCard creditCard = new CreditCard();
        String expected = "John Doe";
        creditCard.setPayerName(expected);
        String actual = creditCard.getPayerName();
        assertEquals(expected, actual);
    }
    @Test
    public void getSetNumberTest() {
        CreditCard creditCard = new CreditCard();
        String expected = "1234567890123456";
        creditCard.setNumber(expected);
        String actual = creditCard.getNumber();
        assertEquals(expected, actual);
    }
    @Test
    public void getSetExpiredMonthTest() {
        CreditCard creditCard = new CreditCard();
        int expectedInt = 01;
        String expected = "01";
        creditCard.setExpiredMonth(expectedInt);
        String actual = creditCard.getExpiredMonth();
        assertEquals(expected, actual);
    }
    @Test
    public void getSetExpiredYearTest() {
        CreditCard creditCard = new CreditCard();
        int expectedInt = 20;
        String expected = "20";
        creditCard.setExpiredYear(expectedInt);
        String actual = creditCard.getExpiredYear();
        assertEquals(expected, actual);
    }
    @Test
    public void getShortDescriptionTest() {
        CreditCard creditCard = new CreditCard();
        creditCard.setPayerName("John Doe");
        creditCard.setNumber("1234567890123456");
        creditCard.setExpiredMonth(01);
        creditCard.setExpiredYear(20);
        String actual = creditCard.getShortDescription();
        String expected = "CC John Doe 3456 01/20";
        assertEquals(expected, actual);
    }

    @Test
    public void compareToCheckTest() {
        CreditCard creditCard = new CreditCard();
        creditCard.setId(1);
        Check check = new Check();
        check.setId(2);
        int actual = creditCard.compareTo(check);
        int expected = -1;
        assertEquals(expected, actual);
    }

    @Test
    public void compareToPaypalTest() {
        Paypal paypal = new Paypal();
        paypal.setId(1);
        CreditCard creditCard = new CreditCard();
        creditCard.setId(1);
        int actual = creditCard.compareTo(paypal);
        int expected = 0;
        assertEquals(expected, actual);
    }

    @Test
    public void compareToPaypalTest2() {
        Paypal paypal = new Paypal();
        paypal.setId(0);
        CreditCard creditCard = new CreditCard();
        creditCard.setId(1);
        int actual = creditCard.compareTo(paypal);
        int expected = 1;
        assertEquals(expected, actual);
    }
}