package com.zipcoder.payment;

import org.junit.Test;

import static org.junit.Assert.*;

public class PaymentSortByPayerTest {

    @Test
    public void compareBeforePayment() {
        PaymentSortByPayer paymentSortByPayer = new PaymentSortByPayer();
        Payment o1 = new CreditCard();
        ((CreditCard) o1).setId(1);
        Payment o2 = new CreditCard();
        ((CreditCard) o2).setId(2);
        int actual = paymentSortByPayer.compare(o1, o2);
        int expected = -1;
        assertEquals(expected, actual);
    }

    @Test
    public void compareSimultaneousPayment() {
        PaymentSortByPayer paymentSortByPayer = new PaymentSortByPayer();
        Payment o1 = new CreditCard();
        ((CreditCard) o1).setId(1);
        Payment o2 = new CreditCard();
        ((CreditCard) o2).setId(1);
        int actual = paymentSortByPayer.compare(o1, o2);
        int expected = 0;
        assertEquals(expected, actual);
    }

    @Test
    public void compareAfterPayment() {
        PaymentSortByPayer paymentSortByPayer = new PaymentSortByPayer();
        Payment o1 = new CreditCard();
        ((CreditCard) o1).setId(1);
        Payment o2 = new CreditCard();
        ((CreditCard) o2).setId(0);
        int actual = paymentSortByPayer.compare(o1, o2);
        int expected = 1;
        assertEquals(expected, actual);
    }
}